package cz.muni.fi.pa165.authorization.server.service;

import cz.muni.fi.pa165.authorization.server.model.CreationUserDto;
import cz.muni.fi.pa165.authorization.server.model.LoginDto;
import cz.muni.fi.pa165.authorization.server.model.LoginResponse;
import cz.muni.fi.pa165.authorization.server.model.UserDto;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class UserService {

    public UserDto getUserById(Long id) {
        return new UserDto()
                .id(id)
                .login("john.doe")
                .firstName("John")
                .lastName("Doe")
                .email("john@example.com")
                .role("manager");
    }

    public UserDto createUser(CreationUserDto creationUserDto) {
        return new UserDto()
                .id(1L)
                .login(creationUserDto.getLogin())
                .firstName(creationUserDto.getFirstName())
                .lastName(creationUserDto.getLastName())
                .email(creationUserDto.getEmail())
                .role(creationUserDto.getRole());
    }

    public UserDto updateUserById(Long id, CreationUserDto creationUserDto) {
        return new UserDto()
                .id(id)
                .login(creationUserDto.getLogin())
                .firstName(creationUserDto.getFirstName())
                .lastName(creationUserDto.getLastName())
                .email(creationUserDto.getEmail())
                .role(creationUserDto.getRole());
    }

    public void deleteUserById(Long id) {

    }

    public LoginResponse login(LoginDto loginDto) {
        return new LoginResponse().token("token-for-" + loginDto.getLogin());
    }

    public List<UserDto> getAllUsers() {
        return List.of(getUserById(1L));
    }
}
