package cz.muni.fi.pa165.core.data.domain;

import cz.muni.fi.pa165.core.data.domain.common.DomainEntity;
import jakarta.persistence.*;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Objects;

@Entity(name = "airplanes")
@Data
@NoArgsConstructor
public class Airplane extends DomainEntity {

    @Column(nullable = false)
    private String name;

    @Column(nullable = false)
    private Integer capacity;

    @ManyToOne(fetch = FetchType.LAZY,
            cascade = {CascadeType.REMOVE, CascadeType.PERSIST, CascadeType.MERGE})
    private AirplaneType type;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Airplane airplane)) {
            return false;
        }
        return Objects.equals(getId(), airplane.getId()) && Objects.equals(getName(), airplane.getName()) &&
                Objects.equals(getCapacity(), airplane.getCapacity()) && Objects.equals(getType(), airplane.getType());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId(), getName(), getCapacity(), getType());
    }
}
