package cz.muni.fi.pa165.core.data.domain;

import cz.muni.fi.pa165.core.data.domain.common.DomainEntity;
import jakarta.persistence.*;
import lombok.*;

import java.io.Serializable;
import java.util.Objects;

@Entity(name = "airplane_types")
@Data
@NoArgsConstructor
public class AirplaneType extends DomainEntity implements Serializable {

    @Column(nullable = false, unique = true)
    private String name;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof AirplaneType airplaneType)) {
            return false;
        }
        return Objects.equals(getName(), airplaneType.getName());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName());
    }
}
