package cz.muni.fi.pa165.core.data.domain;

import cz.muni.fi.pa165.core.data.domain.common.DomainEntity;
import jakarta.persistence.*;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.OffsetDateTime;
import java.util.Collection;
import java.util.Objects;

@Entity
@Table(name = "flights")
@Data
@NoArgsConstructor
public class Flight extends DomainEntity {

    @Column(nullable = false)
    private OffsetDateTime departureTime;

    @Column(nullable = false)
    private OffsetDateTime arrivalTime;

    @OneToMany(mappedBy = "flight")
    private Collection<FlightSteward> flightStewards;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Flight flight)) {
            return false;
        }
        return Objects.equals(getId(), flight.getId()) &&
                Objects.equals(getDepartureTime(), flight.getDepartureTime()) &&
                Objects.equals(getArrivalTime(), flight.getArrivalTime()) &&
                Objects.equals(getFlightStewards(), flight.getFlightStewards());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId(), getDepartureTime(), getArrivalTime(), getFlightStewards());
    }
}
