package cz.muni.fi.pa165.core.data.domain;

import cz.muni.fi.pa165.core.data.domain.common.DomainEntity;
import jakarta.persistence.*;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Collection;
import java.util.Objects;

@Entity
@Table(name = "stewards")
@Data
@NoArgsConstructor
public class Steward extends DomainEntity {

    @Column(nullable = false)
    private String firstName;

    @Column(nullable = false)
    private String lastName;

    @OneToMany(mappedBy = "steward")
    private Collection<FlightSteward> flightStewards;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof Steward steward)) {
            return false;
        }
        return Objects.equals(getId(), steward.getId()) &&
                Objects.equals(getFirstName(), steward.getFirstName()) &&
                Objects.equals(getLastName(), steward.getLastName()) &&
                Objects.equals(getFlightStewards(), steward.getFlightStewards());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId(), getFirstName(), getLastName(), getFlightStewards());
    }
}
