package cz.muni.fi.pa165.core.mapper;

import cz.muni.fi.pa165.core.data.domain.Flight;
import cz.muni.fi.pa165.core.model.FlightDto;
import cz.muni.fi.pa165.core.model.NewFlightDtoRequest;
import org.mapstruct.*;


@Mapper(componentModel = "spring")
public interface FlightMapper {

    Flight toEntity(FlightDto flightDto);

    Flight toEntityFromNewRequest(NewFlightDtoRequest newFlightDtoRequest);

    @Mapping(target = "stewards", source = "flightStewards")
    FlightDto toDto(Flight flight);


    @BeanMapping(nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
    Flight partialUpdate(FlightDto flightDto, @MappingTarget Flight flight);
}
