package cz.muni.fi.pa165.weather.server;

import cz.muni.fi.pa165.weather.server.api.WeatherApiDelegate;
import cz.muni.fi.pa165.weather.server.model.FlightCreationAdvice;
import cz.muni.fi.pa165.weather.server.model.WeatherForecast;
import cz.muni.fi.pa165.weather.server.model.WeatherReason;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

import java.time.OffsetDateTime;

@RestController
public class WeatherController implements WeatherApiDelegate {

    @Override
    public ResponseEntity<WeatherForecast> getWeatherForecast(Double latitude, Double longitude) {
        var weatherForecast = new WeatherForecast()
                .temperature(3.14)
                .windSpeed(15.92)
                .rain(0.8)
                .visibility(6.7);
        return ResponseEntity.ok(weatherForecast);
    }

    @Override
    public ResponseEntity<FlightCreationAdvice> isSafeToCreateFlight(Long departureAirportId, Long arrivalAirportId, OffsetDateTime departureTime, OffsetDateTime arrivalTime) {
        var flightCreationAdvice = new FlightCreationAdvice()
                .result(true)
                .reason(WeatherReason.OK_EVERYTHING);
        return ResponseEntity.ok(flightCreationAdvice);
    }
}
